## org.eclipse.emf.ecore.util
Class BasicExtendedMetaData

    java.lang.Object
      org.eclipse.emf.ecore.util.BasicExtendedMetaData

All Implemented Interfaces:
  ExtendedMetaData

Direct Known Subclasses:
  Ecore2XMLExtendedMetaData, EMOFExtendedMetaData

    public class BasicExtendedMetaData

extends java.lang.Object
implements ExtendedMetaData

This is a basic implementation of the extended metadata API.

Nested Class Summary
`class` `BasicExtendedMetaData.EClassExtendedMetaDataImpl`
`static interface` `BasicExtendedMetaData.EClassifierExtendedMetaData`
`class` `BasicExtendedMetaData.EDataTypeExtendedMetaDataImpl`
`static interface` `BasicExtendedMetaData.EPackageExtendedMetaData`
`class` `BasicExtendedMetaData.EPackageExtendedMetaDataImpl`
`static interface` `BasicExtendedMetaData.EStructuralFeatureExtendedMetaData`
`class` `BasicExtendedMetaData.EStructuralFeatureExtendedMetaDataImpl`

Field Summary
`protected java.util.Map<EModelElement,EAnnotation>` `annotationMap`
`protected java.lang.String` `annotationURI`
`protected EPackage.Registry` `demandRegistry`
`protected java.util.Map<EModelElement,java.lang.Object>` `extendedMetaDataHolderCache`
`protected EPackage.Registry` `registry`
`protected static EDataType` `UNINITIALIZED_EDATA_TYPE`
`protected static EStructuralFeature` `UNINITIALIZED_ESTRUCTURAL_FEATURE`
`protected static int` `UNINITIALIZED_INT`
`protected static java.lang.String` `UNINITIALIZED_STRING`

Fields inherited from interface org.eclipse.emf.ecore.util.ExtendedMetaData

`ANNOTATION_URI, ATTRIBUTE_FEATURE, ATTRIBUTE_WILDCARD_FEATURE, COLLAPSE_WHITE_SPACE, CONTENT_KINDS, DERIVATION_KINDS, ELEMENT_FEATURE, ELEMENT_ONLY_CONTENT, ELEMENT_WILDCARD_FEATURE, EMPTY_CONTENT, FEATURE_KINDS, GROUP_FEATURE, INSTANCE, LAX_PROCESSING, LIST_DERIVATION, MIXED_CONTENT, PRESERVE_WHITE_SPACE, PROCESSING_KINDS, REPLACE_WHITE_SPACE, RESTRICTION_DERIVATION, SIMPLE_CONTENT, SIMPLE_FEATURE, SKIP_PROCESSING, STRICT_PROCESSING, UNION_DERIVATION, UNSPECIFIED_CONTENT, UNSPECIFIED_DERIVATION, UNSPECIFIED_FEATURE, UNSPECIFIED_PROCESSING, UNSPECIFIED_WHITE_SPACE, WHITE_SPACE_KINDS, XMI_URI, XML_SCHEMA_URI, XML_URI, XMLNS_PREFIX, XMLNS_URI, XSI_PREFIX, XSI_URI`

Constructor Summary
`BasicExtendedMetaData()`
`BasicExtendedMetaData(EPackage.Registry registry)`
`BasicExtendedMetaData(java.lang.String annotationURI, EPackage.Registry registry)`
`BasicExtendedMetaData(java.lang.String annotationURI, EPackage.Registry registry, java.util.Map<EModelElement,EAnnotation> annotationMap)`

Method Summary
`protected EStructuralFeature` `basicGetAffiliation(EStructuralFeature eStructuralFeature)`
`EDataType` `basicGetBaseType(EDataType eDataType)`
`protected int` `basicGetContentKind(EClass eClass)`
`protected int` `basicGetDerivationKind(EClassifier eClassifier)`
`protected java.util.List<java.lang.String>` `basicGetEnumerationFacet(EDataType eDataType)`
`protected int` `basicGetFeatureKind(EStructuralFeature eStructuralFeature)`
`protected int` `basicGetFractionDigitsFacet(EDataType eDataType)`
`protected EStructuralFeature` `basicGetGroup(EStructuralFeature eStructuralFeature)`
`protected EDataType` `basicGetItemType(EDataType eDataType)`
`protected int` `basicGetLengthFacet(EDataType eDataType)`
`protected java.lang.String` `basicGetMaxExclusiveFacet(EDataType eDataType)`
`protected java.lang.String` `basicGetMaxInclusiveFacet(EDataType eDataType)`
`protected int` `basicGetMaxLengthFacet(EDataType eDataType)`
`protected java.util.List<EDataType>` `basicGetMemberTypes(EDataType eDataType)`
`protected java.lang.String` `basicGetMinExclusiveFacet(EDataType eDataType)`
`protected java.lang.String` `basicGetMinInclusiveFacet(EDataType eDataType)`
`protected int` `basicGetMinLengthFacet(EDataType eDataType)`
`protected java.lang.String` `basicGetName(EClassifier eClassifier)`
`protected java.lang.String` `basicGetName(EStructuralFeature eStructuralFeature)`
`java.lang.String` `basicGetNamespace(EStructuralFeature eStructuralFeature)`
`protected java.util.List<java.lang.String>` `basicGetPatternFacet(EDataType eDataType)`
`protected int` `basicGetProcessingKind(EStructuralFeature eStructuralFeature)`
`protected int` `basicGetTotalDigitsFacet(EDataType eDataType)`
`protected int` `basicGetWhiteSpaceFacet(EDataType eDataType)`
`protected java.util.List<java.lang.String>` `basicGetWildcards(EStructuralFeature eStructuralFeature)`
`protected boolean` `basicIsQualified(EPackage ePackage)`
`protected java.lang.String` `computePrefix(java.lang.String namespace)`
`protected BasicExtendedMetaData.EClassifierExtendedMetaData` `createEClassifierExtendedMetaData(EClassifier eClassifier)`
`protected BasicExtendedMetaData.EPackageExtendedMetaData` `createEPackageExtendedMetaData(EPackage ePackage)`
`protected BasicExtendedMetaData.EStructuralFeatureExtendedMetaData` `createEStructuralFeatureExtendedMetaData(EStructuralFeature eStructuralFeature)`
`java.util.Collection<EPackage>` `demandedPackages()` Returns the instance's collection of demand-created packages.
`EStructuralFeature` `demandFeature(java.lang.String namespace, java.lang.String name, boolean isElement)` Returns a feature corresponding to a global element or attribute from the namespace-specified package in the demand package registry, creating it, and the package, if necessary.
`EStructuralFeature` `demandFeature(java.lang.String namespace, java.lang.String name, boolean isElement, boolean isReference)` Returns a feature corresponding to a global element or attribute from the namespace-specified package in the demand package registry, creating it, and the package, if necessary.
`EPackage` `demandPackage(java.lang.String namespace)` Returns a package from the demand package registry, creating it (with a document root class) if necessary.
`EClassifier` `demandType(java.lang.String namespace, java.lang.String name)` Returns a class from the namespace-specified package in the demand package registry, demand creating it, and the package, if necessary.
`EStructuralFeature` `getAffiliation(EClass eClass, EStructuralFeature eStructuralFeature)` Returns a structural feature within the given class that is or is associated with the given structural feature.
`EStructuralFeature` `getAffiliation(EStructuralFeature eStructuralFeature)` Returns the substitution group affiliation for the given structural feature, that is, the feature corresponding to the head element of the substitution group to which the element corresponding to the given feature belongs.
`java.util.List<EStructuralFeature>` `getAllAttributes(EClass eClass)` Returns all the structural features of the given class, and its super classes, corresponding to XML attributes and attribute wildcards.
`java.util.List<EStructuralFeature>` `getAllElements(EClass eClass)` Returns all the structural features of the given class, and its super classes, corresponding to elements, element wildards, and model groups.
`protected EAnnotation` `getAnnotation(EModelElement eModelElement, boolean demandCreate)`
`EStructuralFeature` `getAttribute(EClass eClass, java.lang.String namespace, java.lang.String name)` Returns a structural feature within a class, corresponding to a local attribute with the given namespace and name, or, failing that, a document root feature corresponding to a global attribute with the given namespace and name that is `affiliated` with a feature in the class.
`EStructuralFeature` `getAttribute(java.lang.String namespace, java.lang.String name)` Returns the structural feature with the given XML name that corresponds to a global attribute within the package with the given namespace.
`java.util.List<EStructuralFeature>` `getAttributes(EClass eClass)` Returns the structural features of the given class corresponding to XML attributes and attribute wildcards.
`EStructuralFeature` `getAttributeWildcardAffiliation(EClass eClass, java.lang.String namespace, java.lang.String name)` Returns a wildcard feature in the given class that allows allows attribute values from the given namespace.
`EDataType` `getBaseType(EDataType eDataType)` If a data type corresponds to simple type that derives from another by restriction, returns the data type corresponding to the base type.
`int` `getContentKind(EClass eClass)` Returns the kind of XML content of the type corresponding to the given class.
`int` `getDerivationKind(EDataType eDataType)` Returns the derivation kind of the simple type corresponding to the given data type.
`EClass` `getDocumentRoot(EPackage ePackage)` Returns the class corresponding to the document root in the given package.
`EStructuralFeature` `getElement(EClass eClass, java.lang.String namespace, java.lang.String name)` Returns a structural feature within a class, corresponding to a local element with the given namespace and name, or, failing that, a document root feature corresponding to a global element with the given namespace and name that is `affiliated` with a feature in the class.
`EStructuralFeature` `getElement(java.lang.String namespace, java.lang.String name)` Returns the structural feature with the given XML name that corresponds to a global element within the package with the given namespace.
`java.util.List<EStructuralFeature>` `getElements(EClass eClass)` Returns the structural features of the given class corresponding to elements, element wildcards, and model groups.
`EStructuralFeature` `getElementWildcardAffiliation(EClass eClass, java.lang.String namespace, java.lang.String name)` Returns a wildcard feature in the given class that allows allows element values from the given namespace.
`static java.lang.String` `getEncodedWildcards(java.lang.String namespace, java.util.List<java.lang.String> wildcards)`
`java.util.List<java.lang.String>` `getEnumerationFacet(EDataType eDataType)` Returns the enumeration constraint on the given data type.
`protected BasicExtendedMetaData.EClassifierExtendedMetaData` `getExtendedMetaData(EClassifier eClassifier)`
`protected BasicExtendedMetaData.EPackageExtendedMetaData` `getExtendedMetaData(EPackage ePackage)`
`protected BasicExtendedMetaData.EStructuralFeatureExtendedMetaData` `getExtendedMetaData(EStructuralFeature eStructuralFeature)`
`int` `getFeatureKind(EStructuralFeature eStructuralFeature)` Returns the kind of XML structure that should be used to represent the given structural feature.
`int` `getFractionDigitsFacet(EDataType eDataType)` Returns the fraction digits constraint on the given data type.
`EStructuralFeature` `getGroup(EStructuralFeature eStructuralFeature)` Returns the feature respresenting the model group or subtitution group head feature to which the implementation of the given feature is delegated.
`EDataType` `getItemType(EDataType eDataType)` If a data type corresponds to a list type, returns the data type corresponding to its item type.
`int` `getLengthFacet(EDataType eDataType)` Returns the length constraint on the given data type.
`EStructuralFeature` `getLocalAttribute(EClass eClass, java.lang.String namespace, java.lang.String name)`
`protected EStructuralFeature` `getLocalElement(EClass eClass, java.lang.String namespace, java.lang.String name)`
`java.lang.String` `getMaxExclusiveFacet(EDataType eDataType)` Returns the maximum (exclusive) constraint on the given data type.
`java.lang.String` `getMaxInclusiveFacet(EDataType eDataType)` Returns the maximum (inclusive) constraint on the given data type.
`int` `getMaxLengthFacet(EDataType eDataType)` Returns the maximum length constraint on the given data type.
`java.util.List<EDataType>` `getMemberTypes(EDataType eDataType)` If a data type corresponds to a union type, returns the data types corresponding to its member types.
`java.lang.String` `getMinExclusiveFacet(EDataType eDataType)` Returns the minimum (exclusive) constraint on the given data type.
`java.lang.String` `getMinInclusiveFacet(EDataType eDataType)` Returns the minimum (inclusive) constraint on the given data type.
`int` `getMinLengthFacet(EDataType eDataType)` Returns the minumum length constraint on the given data type.
`EAttribute` `getMixedFeature(EClass eClass)` If the given class represents mixed content, returns the wildcard element feature used to store its content.
`java.lang.String` `getName(EClassifier eClassifier)` Returns the XML name for a classifier.
`java.lang.String` `getName(EStructuralFeature eStructuralFeature)` Returns the XML name for a structural feature.
`java.lang.String` `getNamespace(EClassifier eClassifier)` Returns the namespace to use for instances of the given classifier, the same namespace as for the package that contains it.
`java.lang.String` `getNamespace(EPackage ePackage)` Returns the namespace to use for model instance serializations of the specified package.
`java.lang.String` `getNamespace(EStructuralFeature eStructuralFeature)` Returns the namespace associated with the specified structural feature.
`EPackage` `getPackage(java.lang.String namespace)` Retrieves the package with the specified namespace URI from the package registry associated with this instance.
`java.util.List<java.lang.String>` `getPatternFacet(EDataType eDataType)` Returns the pattern constraint on the given data type.
`int` `getProcessingKind(EStructuralFeature eStructuralFeature)` Returns the kind of contents processing to be used for a structural feature corresponding to an any wildcard.
`protected java.lang.String` `getQualifiedName(java.lang.String defaultNamespace, EClassifier eClassifier)`
`protected java.lang.String` `getQualifiedName(java.lang.String defaultNamespace, EStructuralFeature eStructuralFeature)`
`EStructuralFeature` `getSimpleFeature(EClass eClass)` If the given class represents simple content, returns the simple feature used to store its content.
`int` `getTotalDigitsFacet(EDataType eDataType)` Returns the total digits constraint on the given data type.
`EClassifier` `getType(EPackage ePackage, java.lang.String name)` Returns the classifier with the given XML name within the given package.
`EClassifier` `getType(java.lang.String namespace, java.lang.String name)` Returns the classifier with the given XML name within the package with the given namespace.
`int` `getWhiteSpaceFacet(EDataType eDataType)` Returns the white space constraint on the given data type.
`java.util.List<java.lang.String>` `getWildcards(EStructuralFeature eStructuralFeature)` Returns the allowable namespace patterns for a structural feature corresponding to an any or anyAttribute wildcard.
`EReference` `getXMLNSPrefixMapFeature(EClass eClass)` If the given class has mixed content type, returns the "xmlns:prefix" feature, which is used to store namespace prefix-to-URI mappings.
`EReference` `getXSISchemaLocationMapFeature(EClass eClass)` If the given class has mixed content type, returns the "xsi:schemaLocation" feature, which is used to store namespace URI-schema location pairs.
`boolean` `isAnonymous(EClassifier eClassifier)` Returns whether the given classifier's XML name contains "_._", which is used to indicate an anonymous type declaration.
`boolean` `isDocumentRoot(EClass eClass)` Returns whether the given class is a document root, i.e., whether it has an empty string as its XML Name.
`protected boolean` `isFeatureKindSpecific()`
`protected boolean` `isFeatureNamespaceMatchingLax()`
`boolean` `isQualified(EPackage ePackage)` Returns whether model instance serializations of the specified package should use namespace qualification.
`boolean` `matches(java.util.List<java.lang.String> wildcards, java.lang.String namespace)` Tests whether any of a list of wildcards matches a given namespace.
`boolean` `matches(java.lang.String wildcard, java.lang.String namespace)` Tests whether a wildcard matches a given namespace.
`void` `putPackage(java.lang.String namespace, EPackage ePackage)` Adds the package to the package registry associated with this instance, keyed by the given namespace URI.
`void` `setAffiliation(EStructuralFeature eStructuralFeature, EStructuralFeature affiliation)` Sets the substitution group affiliation for the given structural feature.
`void` `setBaseType(EDataType eDataType, EDataType baseType)` Sets the base type for a data type, indicating that the data type corresponds to a simple type that derives from another by restriction.
`void` `setContentKind(EClass eClass, int kind)` Sets the kind of XML content of the type corresponding to the given class.
`void` `setDocumentRoot(EClass eClass)` Sets the specified class to be a document root.
`void` `setEnumerationFacet(EDataType eDataType, java.util.List<java.lang.String> literals)` Sets the enumeration constraint on the given data type.
`void` `setFeatureKind(EStructuralFeature eStructuralFeature, int kind)` Sets the kind of XML structure that should be used to represent the given structural feature.
`void` `setFractionDigitsFacet(EDataType eDataType, int digits)` Sets the fraction digits constraint on the given data type.
`void` `setGroup(EStructuralFeature eStructuralFeature, EStructuralFeature group)` Sets a group or substitution group head feature, to which the implementation of the given feature should be delegated.
`void` `setItemType(EDataType eDataType, EDataType itemType)` Sets the item type for a data type, indicating that the data type corresponds to a list type.
`void` `setLengthFacet(EDataType eDataType, int length)` Sets the length constraint on the given data type.
`void` `setMaxExclusiveFacet(EDataType eDataType, java.lang.String literal)` Sets the maximum (exclusive) constraint on the given data type.
`void` `setMaxInclusiveFacet(EDataType eDataType, java.lang.String literal)` Sets the maximum (inclusive) constraint on the given data type.
`void` `setMaxLengthFacet(EDataType eDataType, int length)` Sets the maximum length constraint on the given data type.
`void` `setMemberTypes(EDataType eDataType, java.util.List<EDataType> memberTypes)` Sets the member types for a data type, indicating that the data type corresponds to a union type.
`void` `setMinExclusiveFacet(EDataType eDataType, java.lang.String literal)` Sets the minimum (exclusive) constraint on the given data type.
`void` `setMinInclusiveFacet(EDataType eDataType, java.lang.String literal)` Sets the minimum (inclusive) constraint on the given data type.
`void` `setMinLengthFacet(EDataType eDataType, int length)` Sets the minimum length constraint on the given data type.
`void` `setName(EClassifier eClassifier, java.lang.String name)` Sets the XML name for a classifier.
`void` `setName(EStructuralFeature eStructuralFeature, java.lang.String name)` Set the XML name for a structural feature.
`void` `setNamespace(EStructuralFeature eStructuralFeature, java.lang.String namespace)` Sets the namespace associated with the specified structural feature.
`void` `setPatternFacet(EDataType eDataType, java.util.List<java.lang.String> pattern)` Sets the pattern constraint on the given data type.
`void` `setProcessingKind(EStructuralFeature eStructuralFeature, int kind)` Sets the kind of contents processing to be used for a structural feature corresponding to an any wildcard.
`void` `setQualified(EPackage ePackage, boolean isQualified)` Sets whether model instance serializations of the specified package should use namespace qualification.
`void` `setTotalDigitsFacet(EDataType eDataType, int digits)` Sets the total digits constraint on the given data type.
`void` `setWhiteSpaceFacet(EDataType eDataType, int whiteSpace)` Sets the white space constraint on the given data type.
`void` `setWildcards(EStructuralFeature eStructuralFeature, java.util.List<java.lang.String> wildcards)` Sets the allowable namespace patterns for a structural feature corresponding to an any or anyAttribute wildcard.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### annotationURI

    protected java.lang.String annotationURI

### registry

    protected EPackage.Registry registry

### demandRegistry

    protected EPackage.Registry demandRegistry

### extendedMetaDataHolderCache

    protected java.util.Map<EModelElement,java.lang.Object> extendedMetaDataHolderCache

### annotationMap

    protected java.util.Map<EModelElement,EAnnotation> annotationMap

### UNINITIALIZED_STRING

    protected static final java.lang.String UNINITIALIZED_STRING

See Also:
  Constant Field Values

### UNINITIALIZED_INT

    protected static final int UNINITIALIZED_INT

See Also:
  Constant Field Values

### UNINITIALIZED_EDATA_TYPE

    protected static final EDataType UNINITIALIZED_EDATA_TYPE

### UNINITIALIZED_ESTRUCTURAL_FEATURE

    protected static final EStructuralFeature UNINITIALIZED_ESTRUCTURAL_FEATURE

Constructor Detail

### BasicExtendedMetaData

    public BasicExtendedMetaData()

### BasicExtendedMetaData

    public BasicExtendedMetaData(EPackage.Registry registry)

### BasicExtendedMetaData

    public BasicExtendedMetaData(java.lang.String annotationURI,
                                 EPackage.Registry registry)

### BasicExtendedMetaData

    public BasicExtendedMetaData(java.lang.String annotationURI,
                                 EPackage.Registry registry,
                                 java.util.Map<EModelElement,EAnnotation> annotationMap)

Method Detail

### getAnnotation

    protected EAnnotation getAnnotation(EModelElement eModelElement,
                                        boolean demandCreate)

### getType

    public EClassifier getType(EPackage ePackage,
                               java.lang.String name)

  Description copied from interface: `ExtendedMetaData`
  Returns the classifier with the given XML name within the given package.

  Specified by:
    `getType` in interface `ExtendedMetaData`

### getPackage

    public EPackage getPackage(java.lang.String namespace)

  Description copied from interface: `ExtendedMetaData`
  Retrieves the package with the specified namespace URI from the package registry associated with this instance.

  Specified by:
    `getPackage` in interface `ExtendedMetaData`

### putPackage

    public void putPackage(java.lang.String namespace,
                           EPackage ePackage)

  Description copied from interface: `ExtendedMetaData`
  Adds the package to the package registry associated with this instance, keyed by the given namespace URI.

  Specified by:
    `putPackage` in interface `ExtendedMetaData`

### getDocumentRoot

    public EClass getDocumentRoot(EPackage ePackage)

  Description copied from interface: `ExtendedMetaData`
  Returns the class corresponding to the document root in the given package. The document root class holds attributes and references corresponding to attributes and elements declared globally in a schema. It is identified by its XML name, an empty string.

  Specified by:
    `getDocumentRoot` in interface `ExtendedMetaData`

### setDocumentRoot

    public void setDocumentRoot(EClass eClass)

  Description copied from interface: `ExtendedMetaData`
  Sets the specified class to be a document root. The document root class holds attributes and references corresponding to attributes and elements declared globally in a schema. Its XML name is set to an empty string, and its content kind to mixed content.

  Specified by:
    `setDocumentRoot` in interface `ExtendedMetaData`

### isDocumentRoot

    public boolean isDocumentRoot(EClass eClass)

  Description copied from interface: `ExtendedMetaData`
  Returns whether the given class is a document root, i.e., whether it has an empty string as its XML Name.

  Specified by:
    `isDocumentRoot` in interface `ExtendedMetaData`

### getXMLNSPrefixMapFeature

    public EReference getXMLNSPrefixMapFeature(EClass eClass)

  Description copied from interface: `ExtendedMetaData`
  If the given class has mixed content type, returns the "xmlns:prefix" feature, which is used to store namespace prefix-to-URI mappings.

  Specified by:
    `getXMLNSPrefixMapFeature` in interface `ExtendedMetaData`

### getXSISchemaLocationMapFeature

    public EReference getXSISchemaLocationMapFeature(EClass eClass)

  Description copied from interface: `ExtendedMetaData`
  If the given class has mixed content type, returns the "xsi:schemaLocation" feature, which is used to store namespace URI-schema location pairs.

  Specified by:
    `getXSISchemaLocationMapFeature` in interface `ExtendedMetaData`

### isQualified

    public boolean isQualified(EPackage ePackage)

  Description copied from interface: `ExtendedMetaData`
  Returns whether model instance serializations of the specified package should use namespace qualification.

  details key: "qualified"

  Specified by:
    `isQualified` in interface `ExtendedMetaData`

### basicIsQualified

    protected boolean basicIsQualified(EPackage ePackage)

### setQualified

    public void setQualified(EPackage ePackage,
                             boolean isQualified)

  Description copied from interface: `ExtendedMetaData`
  Sets whether model instance serializations of the specified package should use namespace qualification.

  details key: "qualified"

  Specified by:
    `setQualified` in interface `ExtendedMetaData`

### getNamespace

    public java.lang.String getNamespace(EPackage ePackage)

  Description copied from interface: `ExtendedMetaData`
  Returns the namespace to use for model instance serializations of the specified package. If namespace qualification is being used, this is the package's namespace URI; if not, it is simply null.

  details key: "namespace"

  Specified by:
    `getNamespace` in interface `ExtendedMetaData`

### getNamespace

    public java.lang.String getNamespace(EClassifier eClassifier)

  Description copied from interface: `ExtendedMetaData`
  Returns the namespace to use for instances of the given classifier, the same namespace as for the package that contains it.

  Specified by:
    `getNamespace` in interface `ExtendedMetaData`

### getNamespace

    public java.lang.String getNamespace(EStructuralFeature eStructuralFeature)

  Description copied from interface: `ExtendedMetaData`
  Returns the namespace associated with the specified structural feature. This allows features to be included in a class that correspond to elements and attributes defined in another schema (i.e. an attribute or element reference).

  Specified by:
    `getNamespace` in interface `ExtendedMetaData`

### basicGetNamespace

    public java.lang.String basicGetNamespace(EStructuralFeature eStructuralFeature)

### setNamespace

    public void setNamespace(EStructuralFeature eStructuralFeature,
                             java.lang.String namespace)

  Description copied from interface: `ExtendedMetaData`
  Sets the namespace associated with the specified structural feature. This allows features to be included in a class that correspond to elements and attributes defined in another schema (i.e. an attribute or element reference).

  Specified by:
    `setNamespace` in interface `ExtendedMetaData`

### getName

    public java.lang.String getName(EClassifier eClassifier)

  Description copied from interface: `ExtendedMetaData`
  Returns the XML name for a classifier. This is the original name specified for the type in the schema, which may be mapped into a valid and conventional Java class name for the Ecore class.

  details key: "name"

  Specified by:
    `getName` in interface `ExtendedMetaData`

### basicGetName

    protected java.lang.String basicGetName(EClassifier eClassifier)

### setName

    public void setName(EClassifier eClassifier,
                        java.lang.String name)

  Description copied from interface: `ExtendedMetaData`
  Sets the XML name for a classifier. This should be the original name specified for the type in the schema, which may be mapped into a valid and conventional Java class name for the Ecore class.

  details key: "name"

  Specified by:
    `setName` in interface `ExtendedMetaData`

### isAnonymous

    public boolean isAnonymous(EClassifier eClassifier)

  Description copied from interface: `ExtendedMetaData`
  Returns whether the given classifier's XML name contains "_._", which is used to indicate an anonymous type declaration.

  Specified by:
    `isAnonymous` in interface `ExtendedMetaData`

### getName

    public java.lang.String getName(EStructuralFeature eStructuralFeature)

  Description copied from interface: `ExtendedMetaData`
  Returns the XML name for a structural feature. This is the original name specified for the element or attribute in the schema, which may be mapped into a valid and conventional Java field name for the Ecore structural feature. This is also the name which should be used for the element or attribute in instance documents.

  details key: "name"

  Specified by:
    `getName` in interface `ExtendedMetaData`

### basicGetName

    protected java.lang.String basicGetName(EStructuralFeature eStructuralFeature)

### setName

    public void setName(EStructuralFeature eStructuralFeature,
                        java.lang.String name)

  Description copied from interface: `ExtendedMetaData`
  Set the XML name for a structural feature. This should be the original name specified for the element or attribute in the schema, which may be mapped into a valid and conventional Java field name for the Ecore structural feature. This is also the name which should be used for the element or attribute in instance documents.

  details key: "name"

  Specified by:
    `setName` in interface `ExtendedMetaData`

### getQualifiedName

    protected java.lang.String getQualifiedName(java.lang.String defaultNamespace,
                                                EClassifier eClassifier)

### getQualifiedName

    protected java.lang.String getQualifiedName(java.lang.String defaultNamespace,
                                                EStructuralFeature eStructuralFeature)

### getType

    public EClassifier getType(java.lang.String namespace,
                               java.lang.String name)

  Description copied from interface: `ExtendedMetaData`
  Returns the classifier with the given XML name within the package with the given namespace.

  Specified by:
    `getType` in interface `ExtendedMetaData`

### getAttribute

    public EStructuralFeature getAttribute(java.lang.String namespace,
                                           java.lang.String name)

  Description copied from interface: `ExtendedMetaData`
  Returns the structural feature with the given XML name that corresponds to a global attribute within the package with the given namespace.

  Specified by:
    `getAttribute` in interface `ExtendedMetaData`

### getElement

    public EStructuralFeature getElement(java.lang.String namespace,
                                         java.lang.String name)

  Description copied from interface: `ExtendedMetaData`
  Returns the structural feature with the given XML name that corresponds to a global element within the package with the given namespace.

  Specified by:
    `getElement` in interface `ExtendedMetaData`

### getFeatureKind

    public int getFeatureKind(EStructuralFeature eStructuralFeature)

  Description copied from interface: `ExtendedMetaData`
  Returns the kind of XML structure that should be used to represent the given structural feature.

  details key: "kind"

  Specified by:
    `getFeatureKind` in interface `ExtendedMetaData`
  See Also:
    `ExtendedMetaData.UNSPECIFIED_FEATURE`, `ExtendedMetaData.SIMPLE_FEATURE`, `ExtendedMetaData.ATTRIBUTE_FEATURE`, `ExtendedMetaData.ATTRIBUTE_WILDCARD_FEATURE`, `ExtendedMetaData.ELEMENT_FEATURE`, `ExtendedMetaData.ELEMENT_WILDCARD_FEATURE`, `ExtendedMetaData.GROUP_FEATURE`

### basicGetFeatureKind

    protected int basicGetFeatureKind(EStructuralFeature eStructuralFeature)

### setFeatureKind

    public void setFeatureKind(EStructuralFeature eStructuralFeature,
                               int kind)

  Description copied from interface: `ExtendedMetaData`
  Sets the kind of XML structure that should be used to represent the given structural feature.

  details key: "kind"

  Specified by:
    `setFeatureKind` in interface `ExtendedMetaData`
  See Also:
    `ExtendedMetaData.UNSPECIFIED_FEATURE`, `ExtendedMetaData.SIMPLE_FEATURE`, `ExtendedMetaData.ATTRIBUTE_FEATURE`, `ExtendedMetaData.ATTRIBUTE_WILDCARD_FEATURE`, `ExtendedMetaData.ELEMENT_FEATURE`, `ExtendedMetaData.ELEMENT_WILDCARD_FEATURE`, `ExtendedMetaData.GROUP_FEATURE`

### getContentKind

    public int getContentKind(EClass eClass)

  Description copied from interface: `ExtendedMetaData`
  Returns the kind of XML content of the type corresponding to the given class.

  details key: "kind"

  Specified by:
    `getContentKind` in interface `ExtendedMetaData`
  See Also:
    `ExtendedMetaData.UNSPECIFIED_CONTENT`, `ExtendedMetaData.EMPTY_CONTENT`, `ExtendedMetaData.SIMPLE_CONTENT`, `ExtendedMetaData.MIXED_CONTENT`, `ExtendedMetaData.ELEMENT_ONLY_CONTENT`

### basicGetContentKind

    protected int basicGetContentKind(EClass eClass)

### setContentKind

    public void setContentKind(EClass eClass,
                               int kind)

  Description copied from interface: `ExtendedMetaData`
  Sets the kind of XML content of the type corresponding to the given class.

  details key: "kind"

  Specified by:
    `setContentKind` in interface `ExtendedMetaData`
  See Also:
    `ExtendedMetaData.UNSPECIFIED_CONTENT`, `ExtendedMetaData.EMPTY_CONTENT`, `ExtendedMetaData.SIMPLE_CONTENT`, `ExtendedMetaData.MIXED_CONTENT`, `ExtendedMetaData.ELEMENT_ONLY_CONTENT`

### getDerivationKind

    public int getDerivationKind(EDataType eDataType)

  Description copied from interface: `ExtendedMetaData`
  Returns the derivation kind of the simple type corresponding to the given data type.

  Specified by:
    `getDerivationKind` in interface `ExtendedMetaData`
  See Also:
    `ExtendedMetaData.UNSPECIFIED_DERIVATION`, `ExtendedMetaData.RESTRICTION_DERIVATION`, `ExtendedMetaData.LIST_DERIVATION`, `ExtendedMetaData.UNION_DERIVATION`

### basicGetDerivationKind

    protected int basicGetDerivationKind(EClassifier eClassifier)

### getBaseType

    public EDataType getBaseType(EDataType eDataType)

  Description copied from interface: `ExtendedMetaData`
  If a data type corresponds to simple type that derives from another by restriction, returns the data type corresponding to the base type.

  details key: "baseType"

  Specified by:
    `getBaseType` in interface `ExtendedMetaData`

### basicGetBaseType

    public EDataType basicGetBaseType(EDataType eDataType)

### setBaseType

    public void setBaseType(EDataType eDataType,
                            EDataType baseType)

  Description copied from interface: `ExtendedMetaData`
  Sets the base type for a data type, indicating that the data type corresponds to a simple type that derives from another by restriction.

  details key: "baseType"

  Specified by:
    `setBaseType` in interface `ExtendedMetaData`

### getItemType

    public EDataType getItemType(EDataType eDataType)

  Description copied from interface: `ExtendedMetaData`
  If a data type corresponds to a list type, returns the data type corresponding to its item type.

  details key: "itemType"

  Specified by:
    `getItemType` in interface `ExtendedMetaData`

### basicGetItemType

    protected EDataType basicGetItemType(EDataType eDataType)

### setItemType

    public void setItemType(EDataType eDataType,
                            EDataType itemType)

  Description copied from interface: `ExtendedMetaData`
  Sets the item type for a data type, indicating that the data type corresponds to a list type.

  details key: "itemType"

  Specified by:
    `setItemType` in interface `ExtendedMetaData`

### getMemberTypes

    public java.util.List<EDataType> getMemberTypes(EDataType eDataType)

  Description copied from interface: `ExtendedMetaData`
  If a data type corresponds to a union type, returns the data types corresponding to its member types.

  details key: "memberTypes"

  Specified by:
    `getMemberTypes` in interface `ExtendedMetaData`

### basicGetMemberTypes

    protected java.util.List<EDataType> basicGetMemberTypes(EDataType eDataType)

### setMemberTypes

    public void setMemberTypes(EDataType eDataType,
                               java.util.List<EDataType> memberTypes)

  Description copied from interface: `ExtendedMetaData`
  Sets the member types for a data type, indicating that the data type corresponds to a union type.

  details key: "memberTypes"

  Specified by:
    `setMemberTypes` in interface `ExtendedMetaData`

### isFeatureKindSpecific

    protected boolean isFeatureKindSpecific()

### isFeatureNamespaceMatchingLax

    protected boolean isFeatureNamespaceMatchingLax()

### getLocalAttribute

    public EStructuralFeature getLocalAttribute(EClass eClass,
                                                java.lang.String namespace,
                                                java.lang.String name)

### getAttribute

    public EStructuralFeature getAttribute(EClass eClass,
                                           java.lang.String namespace,
                                           java.lang.String name)

  Description copied from interface: `ExtendedMetaData`
  Returns a structural feature within a class, corresponding to a local attribute with the given namespace and name, or, failing that, a document root feature corresponding to a global attribute with the given namespace and name that is `affiliated` with a feature in the class.

  Specified by:
    `getAttribute` in interface `ExtendedMetaData`

### getLocalElement

    protected EStructuralFeature getLocalElement(EClass eClass,
                                                 java.lang.String namespace,
                                                 java.lang.String name)

### getElement

    public EStructuralFeature getElement(EClass eClass,
                                         java.lang.String namespace,
                                         java.lang.String name)

  Description copied from interface: `ExtendedMetaData`
  Returns a structural feature within a class, corresponding to a local element with the given namespace and name, or, failing that, a document root feature corresponding to a global element with the given namespace and name that is `affiliated` with a feature in the class.

  Specified by:
    `getElement` in interface `ExtendedMetaData`

### getAllAttributes

    public java.util.List<EStructuralFeature> getAllAttributes(EClass eClass)

  Description copied from interface: `ExtendedMetaData`
  Returns all the structural features of the given class, and its super classes, corresponding to XML attributes and attribute wildcards.

  Specified by:
    `getAllAttributes` in interface `ExtendedMetaData`

### getAllElements

    public java.util.List<EStructuralFeature> getAllElements(EClass eClass)

  Description copied from interface: `ExtendedMetaData`
  Returns all the structural features of the given class, and its super classes, corresponding to elements, element wildards, and model groups.

  Specified by:
    `getAllElements` in interface `ExtendedMetaData`

### getAttributes

    public java.util.List<EStructuralFeature> getAttributes(EClass eClass)

  Description copied from interface: `ExtendedMetaData`
  Returns the structural features of the given class corresponding to XML attributes and attribute wildcards.

  Specified by:
    `getAttributes` in interface `ExtendedMetaData`

### getElements

    public java.util.List<EStructuralFeature> getElements(EClass eClass)

  Description copied from interface: `ExtendedMetaData`
  Returns the structural features of the given class corresponding to elements, element wildcards, and model groups.

  Specified by:
    `getElements` in interface `ExtendedMetaData`

### getSimpleFeature

    public EStructuralFeature getSimpleFeature(EClass eClass)

  Description copied from interface: `ExtendedMetaData`
  If the given class represents simple content, returns the simple feature used to store its content.

  Specified by:
    `getSimpleFeature` in interface `ExtendedMetaData`

### getMixedFeature

    public EAttribute getMixedFeature(EClass eClass)

  Description copied from interface: `ExtendedMetaData`
  If the given class represents mixed content, returns the wildcard element feature used to store its content.

  Specified by:
    `getMixedFeature` in interface `ExtendedMetaData`

### getWildcards

    public java.util.List<java.lang.String> getWildcards(EStructuralFeature eStructuralFeature)

  Description copied from interface: `ExtendedMetaData`
  Returns the allowable namespace patterns for a structural feature corresponding to an any or anyAttribute wildcard.

  details key: "wildcards"

  Specified by:
    `getWildcards` in interface `ExtendedMetaData`

### basicGetWildcards

    protected java.util.List<java.lang.String> basicGetWildcards(EStructuralFeature eStructuralFeature)

### setWildcards

    public void setWildcards(EStructuralFeature eStructuralFeature,
                             java.util.List<java.lang.String> wildcards)

  Description copied from interface: `ExtendedMetaData`
  Sets the allowable namespace patterns for a structural feature corresponding to an any or anyAttribute wildcard.

  details key: "wildcards"

  Specified by:
    `setWildcards` in interface `ExtendedMetaData`

### getEncodedWildcards

    public static java.lang.String getEncodedWildcards(java.lang.String namespace,
                                                       java.util.List<java.lang.String> wildcards)

### getProcessingKind

    public int getProcessingKind(EStructuralFeature eStructuralFeature)

  Description copied from interface: `ExtendedMetaData`
  Returns the kind of contents processing to be used for a structural feature corresponding to an any wildcard.

  details key: "processing"

  Specified by:
    `getProcessingKind` in interface `ExtendedMetaData`
  See Also:
    `ExtendedMetaData.UNSPECIFIED_PROCESSING`, `ExtendedMetaData.STRICT_PROCESSING`, `ExtendedMetaData.LAX_PROCESSING`, `ExtendedMetaData.SKIP_PROCESSING`

### basicGetProcessingKind

    protected int basicGetProcessingKind(EStructuralFeature eStructuralFeature)

### setProcessingKind

    public void setProcessingKind(EStructuralFeature eStructuralFeature,
                                  int kind)

  Description copied from interface: `ExtendedMetaData`
  Sets the kind of contents processing to be used for a structural feature corresponding to an any wildcard.

  details key: "processing"

  Specified by:
    `setProcessingKind` in interface `ExtendedMetaData`
  See Also:
    `ExtendedMetaData.UNSPECIFIED_PROCESSING`, `ExtendedMetaData.STRICT_PROCESSING`, `ExtendedMetaData.LAX_PROCESSING`, `ExtendedMetaData.SKIP_PROCESSING`

### getGroup

    public EStructuralFeature getGroup(EStructuralFeature eStructuralFeature)

  Description copied from interface: `ExtendedMetaData`
  Returns the feature respresenting the model group or subtitution group head feature to which the implementation of the given feature is delegated.

  details key: "group"

  Specified by:
    `getGroup` in interface `ExtendedMetaData`

### basicGetGroup

    protected EStructuralFeature basicGetGroup(EStructuralFeature eStructuralFeature)

### setGroup

    public void setGroup(EStructuralFeature eStructuralFeature,
                         EStructuralFeature group)

  Description copied from interface: `ExtendedMetaData`
  Sets a group or substitution group head feature, to which the implementation of the given feature should be delegated.

  details key: "group"

  Specified by:
    `setGroup` in interface `ExtendedMetaData`

### getAffiliation

    public EStructuralFeature getAffiliation(EStructuralFeature eStructuralFeature)

  Description copied from interface: `ExtendedMetaData`
  Returns the substitution group affiliation for the given structural feature, that is, the feature corresponding to the head element of the substitution group to which the element corresponding to the given feature belongs.

  details key: "affiliation"

  Specified by:
    `getAffiliation` in interface `ExtendedMetaData`

### basicGetAffiliation

    protected EStructuralFeature basicGetAffiliation(EStructuralFeature eStructuralFeature)

### setAffiliation

    public void setAffiliation(EStructuralFeature eStructuralFeature,
                               EStructuralFeature affiliation)

  Description copied from interface: `ExtendedMetaData`
  Sets the substitution group affiliation for the given structural feature. Both feature and its affiliation feature should be in a document root class, such that they correspond to global structural feature declarations.

  details key: "affiliation"

  Specified by:
    `setAffiliation` in interface `ExtendedMetaData`

### getAffiliation

    public EStructuralFeature getAffiliation(EClass eClass,
                                             EStructuralFeature eStructuralFeature)

  Description copied from interface: `ExtendedMetaData`
  Returns a structural feature within the given class that is or is associated with the given structural feature. If the feature corresponds to an attribute, it will return the given feature itself, a feature matching the given one in the document root (corresponding to a reference to the global attribute), or a wildcard attribute feature appropriate for the namespace of the given feature. If it corresponds to an element, it will return the feature itself, a feature matching it in the document root or its affiliations (corresponding to a reference to the global element, or its head, or its head's head, etc.), the mixed content feature for an XML type (text, CDATA, or comment), or a wildcard element feature appropriate for the namespace of the given feature.

  Specified by:
    `getAffiliation` in interface `ExtendedMetaData`

### getAttributeWildcardAffiliation

    public EStructuralFeature getAttributeWildcardAffiliation(EClass eClass,
                                                              java.lang.String namespace,
                                                              java.lang.String name)

  Description copied from interface: `ExtendedMetaData`
  Returns a wildcard feature in the given class that allows allows attribute values from the given namespace.

  Specified by:
    `getAttributeWildcardAffiliation` in interface `ExtendedMetaData`

### getElementWildcardAffiliation

    public EStructuralFeature getElementWildcardAffiliation(EClass eClass,
                                                            java.lang.String namespace,
                                                            java.lang.String name)

  Description copied from interface: `ExtendedMetaData`
  Returns a wildcard feature in the given class that allows allows element values from the given namespace.

  Specified by:
    `getElementWildcardAffiliation` in interface `ExtendedMetaData`

### matches

    public boolean matches(java.util.List<java.lang.String> wildcards,
                           java.lang.String namespace)

  Description copied from interface: `ExtendedMetaData`
  Tests whether any of a list of wildcards matches a given namespace.

  Specified by:
    `matches` in interface `ExtendedMetaData`

### matches

    public boolean matches(java.lang.String wildcard,
                           java.lang.String namespace)

  Description copied from interface: `ExtendedMetaData`
  Tests whether a wildcard matches a given namespace.

  Specified by:
    `matches` in interface `ExtendedMetaData`

### getWhiteSpaceFacet

    public int getWhiteSpaceFacet(EDataType eDataType)

  Description copied from interface: `ExtendedMetaData`
  Returns the white space constraint on the given data type.

  details key: "whiteSpace"

  Specified by:
    `getWhiteSpaceFacet` in interface `ExtendedMetaData`
  See Also:
    `ExtendedMetaData.UNSPECIFIED_WHITE_SPACE`, `ExtendedMetaData.PRESERVE_WHITE_SPACE`, `ExtendedMetaData.REPLACE_WHITE_SPACE`, `ExtendedMetaData.COLLAPSE_WHITE_SPACE`

### basicGetWhiteSpaceFacet

    protected int basicGetWhiteSpaceFacet(EDataType eDataType)

### setWhiteSpaceFacet

    public void setWhiteSpaceFacet(EDataType eDataType,
                                   int whiteSpace)

  Description copied from interface: `ExtendedMetaData`
  Sets the white space constraint on the given data type.

  details key: "whiteSpace"

  Specified by:
    `setWhiteSpaceFacet` in interface `ExtendedMetaData`
  See Also:
    `ExtendedMetaData.UNSPECIFIED_WHITE_SPACE`, `ExtendedMetaData.PRESERVE_WHITE_SPACE`, `ExtendedMetaData.REPLACE_WHITE_SPACE`, `ExtendedMetaData.COLLAPSE_WHITE_SPACE`

### getEnumerationFacet

    public java.util.List<java.lang.String> getEnumerationFacet(EDataType eDataType)

  Description copied from interface: `ExtendedMetaData`
  Returns the enumeration constraint on the given data type.

  details key: "enumeration"

  Specified by:
    `getEnumerationFacet` in interface `ExtendedMetaData`

### basicGetEnumerationFacet

    protected java.util.List<java.lang.String> basicGetEnumerationFacet(EDataType eDataType)

### setEnumerationFacet

    public void setEnumerationFacet(EDataType eDataType,
                                    java.util.List<java.lang.String> literals)

  Description copied from interface: `ExtendedMetaData`
  Sets the enumeration constraint on the given data type.

  details key: "enumeration"

  Specified by:
    `setEnumerationFacet` in interface `ExtendedMetaData`

### getPatternFacet

    public java.util.List<java.lang.String> getPatternFacet(EDataType eDataType)

  Description copied from interface: `ExtendedMetaData`
  Returns the pattern constraint on the given data type.

  details key: "pattern"

  Specified by:
    `getPatternFacet` in interface `ExtendedMetaData`

### basicGetPatternFacet

    protected java.util.List<java.lang.String> basicGetPatternFacet(EDataType eDataType)

### setPatternFacet

    public void setPatternFacet(EDataType eDataType,
                                java.util.List<java.lang.String> pattern)

  Description copied from interface: `ExtendedMetaData`
  Sets the pattern constraint on the given data type.

  details key: "pattern"

  Specified by:
    `setPatternFacet` in interface `ExtendedMetaData`

### getTotalDigitsFacet

    public int getTotalDigitsFacet(EDataType eDataType)

  Description copied from interface: `ExtendedMetaData`
  Returns the total digits constraint on the given data type.

  details key: "totalDigits"

  Specified by:
    `getTotalDigitsFacet` in interface `ExtendedMetaData`

### basicGetTotalDigitsFacet

    protected int basicGetTotalDigitsFacet(EDataType eDataType)

### setTotalDigitsFacet

    public void setTotalDigitsFacet(EDataType eDataType,
                                    int digits)

  Description copied from interface: `ExtendedMetaData`
  Sets the total digits constraint on the given data type.

  details key: "totalDigits"

  Specified by:
    `setTotalDigitsFacet` in interface `ExtendedMetaData`

### getFractionDigitsFacet

    public int getFractionDigitsFacet(EDataType eDataType)

  Description copied from interface: `ExtendedMetaData`
  Returns the fraction digits constraint on the given data type.

  details key: "fractionDigits"

  Specified by:
    `getFractionDigitsFacet` in interface `ExtendedMetaData`

### basicGetFractionDigitsFacet

    protected int basicGetFractionDigitsFacet(EDataType eDataType)

### setFractionDigitsFacet

    public void setFractionDigitsFacet(EDataType eDataType,
                                       int digits)

  Description copied from interface: `ExtendedMetaData`
  Sets the fraction digits constraint on the given data type.

  details key: "fractionDigits"

  Specified by:
    `setFractionDigitsFacet` in interface `ExtendedMetaData`

### getLengthFacet

    public int getLengthFacet(EDataType eDataType)

  Description copied from interface: `ExtendedMetaData`
  Returns the length constraint on the given data type.

  details key: "length"

  Specified by:
    `getLengthFacet` in interface `ExtendedMetaData`

### basicGetLengthFacet

    protected int basicGetLengthFacet(EDataType eDataType)

### setLengthFacet

    public void setLengthFacet(EDataType eDataType,
                               int length)

  Description copied from interface: `ExtendedMetaData`
  Sets the length constraint on the given data type.

  details key: "length"

  Specified by:
    `setLengthFacet` in interface `ExtendedMetaData`

### getMinLengthFacet

    public int getMinLengthFacet(EDataType eDataType)

  Description copied from interface: `ExtendedMetaData`
  Returns the minumum length constraint on the given data type.

  details key: "minLength"

  Specified by:
    `getMinLengthFacet` in interface `ExtendedMetaData`

### basicGetMinLengthFacet

    protected int basicGetMinLengthFacet(EDataType eDataType)

### setMinLengthFacet

    public void setMinLengthFacet(EDataType eDataType,
                                  int length)

  Description copied from interface: `ExtendedMetaData`
  Sets the minimum length constraint on the given data type.

  details key: "minLength"

  Specified by:
    `setMinLengthFacet` in interface `ExtendedMetaData`

### getMaxLengthFacet

    public int getMaxLengthFacet(EDataType eDataType)

  Description copied from interface: `ExtendedMetaData`
  Returns the maximum length constraint on the given data type.

  details key: "maxLength"

  Specified by:
    `getMaxLengthFacet` in interface `ExtendedMetaData`

### basicGetMaxLengthFacet

    protected int basicGetMaxLengthFacet(EDataType eDataType)

### setMaxLengthFacet

    public void setMaxLengthFacet(EDataType eDataType,
                                  int length)

  Description copied from interface: `ExtendedMetaData`
  Sets the maximum length constraint on the given data type.

  details key: "maxLength"

  Specified by:
    `setMaxLengthFacet` in interface `ExtendedMetaData`

### getMinExclusiveFacet

    public java.lang.String getMinExclusiveFacet(EDataType eDataType)

  Description copied from interface: `ExtendedMetaData`
  Returns the minimum (exclusive) constraint on the given data type.

  details key: "minExclusive"

  Specified by:
    `getMinExclusiveFacet` in interface `ExtendedMetaData`

### basicGetMinExclusiveFacet

    protected java.lang.String basicGetMinExclusiveFacet(EDataType eDataType)

### setMinExclusiveFacet

    public void setMinExclusiveFacet(EDataType eDataType,
                                     java.lang.String literal)

  Description copied from interface: `ExtendedMetaData`
  Sets the minimum (exclusive) constraint on the given data type.

  details key: "minExclusive"

  Specified by:
    `setMinExclusiveFacet` in interface `ExtendedMetaData`

### getMaxExclusiveFacet

    public java.lang.String getMaxExclusiveFacet(EDataType eDataType)

  Description copied from interface: `ExtendedMetaData`
  Returns the maximum (exclusive) constraint on the given data type.

  details key: "maxExclusive"

  Specified by:
    `getMaxExclusiveFacet` in interface `ExtendedMetaData`

### basicGetMaxExclusiveFacet

    protected java.lang.String basicGetMaxExclusiveFacet(EDataType eDataType)

### setMaxExclusiveFacet

    public void setMaxExclusiveFacet(EDataType eDataType,
                                     java.lang.String literal)

  Description copied from interface: `ExtendedMetaData`
  Sets the maximum (exclusive) constraint on the given data type.

  details key: "maxExclusive"

  Specified by:
    `setMaxExclusiveFacet` in interface `ExtendedMetaData`

### getMinInclusiveFacet

    public java.lang.String getMinInclusiveFacet(EDataType eDataType)

  Description copied from interface: `ExtendedMetaData`
  Returns the minimum (inclusive) constraint on the given data type.

  details key: "minInclusive"

  Specified by:
    `getMinInclusiveFacet` in interface `ExtendedMetaData`

### basicGetMinInclusiveFacet

    protected java.lang.String basicGetMinInclusiveFacet(EDataType eDataType)

### setMinInclusiveFacet

    public void setMinInclusiveFacet(EDataType eDataType,
                                     java.lang.String literal)

  Description copied from interface: `ExtendedMetaData`
  Sets the minimum (inclusive) constraint on the given data type.

  details key: "minInclusive"

  Specified by:
    `setMinInclusiveFacet` in interface `ExtendedMetaData`

### getMaxInclusiveFacet

    public java.lang.String getMaxInclusiveFacet(EDataType eDataType)

  Description copied from interface: `ExtendedMetaData`
  Returns the maximum (inclusive) constraint on the given data type.

  details key: "maxInclusive"

  Specified by:
    `getMaxInclusiveFacet` in interface `ExtendedMetaData`

### basicGetMaxInclusiveFacet

    protected java.lang.String basicGetMaxInclusiveFacet(EDataType eDataType)

### setMaxInclusiveFacet

    public void setMaxInclusiveFacet(EDataType eDataType,
                                     java.lang.String literal)

  Description copied from interface: `ExtendedMetaData`
  Sets the maximum (inclusive) constraint on the given data type.

  details key: "maxInclusive"

  Specified by:
    `setMaxInclusiveFacet` in interface `ExtendedMetaData`

### demandPackage

    public EPackage demandPackage(java.lang.String namespace)

  Description copied from interface: `ExtendedMetaData`
  Returns a package from the demand package registry, creating it (with a document root class) if necessary.

  Specified by:
    `demandPackage` in interface `ExtendedMetaData`

### computePrefix

    protected java.lang.String computePrefix(java.lang.String namespace)

### demandType

    public EClassifier demandType(java.lang.String namespace,
                                  java.lang.String name)

  Description copied from interface: `ExtendedMetaData`
  Returns a class from the namespace-specified package in the demand package registry, demand creating it, and the package, if necessary.

  Specified by:
    `demandType` in interface `ExtendedMetaData`

### demandFeature

    public EStructuralFeature demandFeature(java.lang.String namespace,
                                            java.lang.String name,
                                            boolean isElement)

  Description copied from interface: `ExtendedMetaData`
  Returns a feature corresponding to a global element or attribute from the namespace-specified package in the demand package registry, creating it, and the package, if necessary. Elements are created as references and attributes as attributes.

  Specified by:
    `demandFeature` in interface `ExtendedMetaData`

### demandFeature

    public EStructuralFeature demandFeature(java.lang.String namespace,
                                            java.lang.String name,
                                            boolean isElement,
                                            boolean isReference)

  Description copied from interface: `ExtendedMetaData`
  Returns a feature corresponding to a global element or attribute from the namespace-specified package in the demand package registry, creating it, and the package, if necessary.

  Specified by:
    `demandFeature` in interface `ExtendedMetaData`

### demandedPackages

    public java.util.Collection<EPackage> demandedPackages()

  Description copied from interface: `ExtendedMetaData`
  Returns the instance's collection of demand-created packages.

  Specified by:
    `demandedPackages` in interface `ExtendedMetaData`

### getExtendedMetaData

    protected BasicExtendedMetaData.EPackageExtendedMetaData getExtendedMetaData(EPackage ePackage)

### createEPackageExtendedMetaData

    protected BasicExtendedMetaData.EPackageExtendedMetaData createEPackageExtendedMetaData(EPackage ePackage)

### getExtendedMetaData

    protected BasicExtendedMetaData.EClassifierExtendedMetaData getExtendedMetaData(EClassifier eClassifier)

### createEClassifierExtendedMetaData

    protected BasicExtendedMetaData.EClassifierExtendedMetaData createEClassifierExtendedMetaData(EClassifier eClassifier)

### getExtendedMetaData

    protected BasicExtendedMetaData.EStructuralFeatureExtendedMetaData getExtendedMetaData(EStructuralFeature eStructuralFeature)

### createEStructuralFeatureExtendedMetaData

    protected BasicExtendedMetaData.EStructuralFeatureExtendedMetaData createEStructuralFeatureExtendedMetaData(EStructuralFeature eStructuralFeature)

Copyright 2001-2006 IBM Corporation and others. All Rights Reserved.